<?php
/**
 * Zarafa Z-Merge SugarCRM Connector
 *
 * Copyright (C) 2005 - 2008  Zarafa B.V.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License, version 3,
 * and under the terms of the GNU General Public License, version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU (Affero) General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * and the GNU General Public License along with this program.
 * If not, see <http://www.gnu.org/licenses/>.
 *
 * Created on 10.06.2008 by Sebastian Kummer & Manfred Kutas
 *
 * NOTE: This sction shows status of the archived message and offers a button
 * to close the popup
 *
 * @package Z-Merge
 * @subpackage SugarCRM-Connector
 */


if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once('include/utils.php');
require_once('XTemplate/xtpl.php');


global $theme;
$theme_path="themes/".$theme."/";
$image_path=$theme_path."images/";
require_once($theme_path.'layout_utils.php');
// SugarCRM 5.5 fix
if (file_exists($theme_path.'config.php'))
    require($theme_path.'config.php');
else
    require($theme_path.'themedef.php');

global $app_strings;
global $app_list_strings;
global $mod_strings;
global $current_user;
global $sugar_version, $sugar_config;
global $timedate;


$xtpl=new XTemplate('modules/ZMerge/gui.archivePopup.html');

///////////////////////////////////////////////////////////////////////////////
////	GENERAL TEMPLATE ASSIGNMENTS
$xtpl->assign('MOD', $mod_strings);
$xtpl->assign('APP', $app_strings);


if(!isset($focus->id)) $xtpl->assign('USER_ID', $current_user->id);


$xtpl->assign('THEME', $theme);
$xtpl->assign('IMAGE_PATH', $image_path);
$xtpl->assign('PRINT_URL', 'index.php?'.$GLOBALS['request_string']);


require_once("include/globalControlLinks.php");
$image_server = '';
if(defined('TEMPLATE_URL'))$image_server = TEMPLATE_URL . '/';
$xtpl->assign("IMAGE_SERVER", $image_server);
$xtpl->assign("IMAGE_PATH", $image_path);
$company_logo = $image_path . 'company_logo.png';
if(file_exists('custom/' . $company_logo)){
    $company_logo = 'custom/' . $company_logo;
}
// SugarCRM 5.5 fix
if (!file_exists($company_logo)) {
    $company_logo = 'themes/default/images/company_logo.png';
}

$text = "<br><center><br><br><br>";

if (isset($_REQUEST['record']) && $_REQUEST['record'] != "") {
    $text .= "<h4>Archived sucessfully</h4>";
    $text .= "<b><a href='index.php?action=DetailView&module=Emails&record={$_REQUEST['record']}' onClick='closeWindowSoon();' target='_blank'>View archived email</a></b>";
}
else if ($_REQUEST['record'] == "") {
    $text .= "<h4>Archival cancelled</h4>";
}


$text .= "<br><br>	<a href='javascript: window.close();'><h3>Close window</h3></a><br><br></center>";
$xtpl->assign("MESSAGE", $text);



insert_popup_header($theme);
$xtpl->assign('COMPANY_LOGO', $company_logo);
$xtpl->assign("PRINT_URL", "index.php?".$GLOBALS['request_string']);
$xtpl->assign("MODULE_NAME", (isset($currentModule))?$currentModule:'ZMerge' );
$xtpl->assign("DATE", date("Y-m-d"));
$xtpl->assign("TITLE", $app_strings['LBL_SEARCH']);

if ($current_user->first_name != '') $xtpl->assign("CURRENT_USER", $current_user->first_name);
else $xtpl->assign("CURRENT_USER", $current_user->user_name);

$xtpl->assign("CURRENT_USER_ID", $current_user->id);
$xtpl->assign("ID", (isset($mailid))?$mailid:0);

$i = 0;
foreach($global_control_links as $key => $value) {
    if ($key=='users')  {   //represents logout link.
        $xtpl->assign("LOGOUT_LINK", $value['linkinfo'][key($value['linkinfo'])]);
        $xtpl->assign("LOGOUT_LABEL", key($value['linkinfo']));//key value for first element.
        break;
    }
}

$xtpl->parse("header");
$xtpl->out("header");

if (function_exists("get_form_footer"))
    echo get_form_footer();
insert_popup_footer();

?>
<script language="JavaScript">
<!--

function closeWindowSoon() {
	window.setTimeout("closeThis()", 800);
}

function closeThis() {
	window.close();
}
-->
</script>
