<?php
/**
 * Zarafa Z-Merge SugarCRM Connector
 *
 * Copyright (C) 2005 - 2008  Zarafa B.V.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License, version 3,
 * and under the terms of the GNU General Public License, version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU (Affero) General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * and the GNU General Public License along with this program.
 * If not, see <http://www.gnu.org/licenses/>.
 *
 * Created on 10.06.2008 by Sebastian Kummer & Manfred Kutas
 *
 * NOTE: Window to be seen so that a user can assign related
 * objects to the (not yet) archived-Mail
 *
 * @requires Pear-Mail
 * @package Z-Merge
 * @subpackage SugarCRM-Connector
 */

if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once('data/SugarBean.php');
require_once('modules/Emails/Email.php');
require_once('modules/Notes/Note.php');
require_once('include/utils.php');
require_once('XTemplate/xtpl.php');

require_once('include/mimeDecode.php');
include_once('include/z_RFC822.php');
require_once('inc.utils.php');


global $theme;
$theme_path="themes/".$theme."/";
$image_path=$theme_path."images/";
// SugarCRM 6 fix
if (file_exists($theme_path.'layout_utils.php'))
    require_once($theme_path.'layout_utils.php');

// SugarCRM 5.5 fix
if (file_exists($theme_path.'config.php'))
    require($theme_path.'config.php');
else
    require($theme_path.'themedef.php');


global $app_strings;
global $app_list_strings;
global $mod_strings;
global $current_user;
global $sugar_version, $sugar_config;
global $timedate;
global $currentModule;


$default_charset = $sugar_config['default_charset'];
$module_path="modules/".$currentModule."/";
load_menu($module_path);


// read and parse the RFC822 message
$filename = $sugar_config['upload_dir'] . stripslashes($_REQUEST['record']) . ".eml";

if (file_exists($filename)) {
    // read and parse the email
    $rfc822 = file_get_contents($filename);
    $mobj = new Mail_mimeDecode($rfc822);
    $message = $mobj->decode(array('decode_headers' => true, 'decode_bodies' => true, 'include_bodies' => true, 'input' => $rfc822, 'crlf' => "\n", 'charset' => 'utf-8'));

    $toaddr = $ccaddr = $bccaddr = "";
    if(isset($message->headers["to"]))
        $toaddr = parseAddr(Mail_RFC822::parseAddressList($message->headers["to"]));
    if(isset($message->headers["from"]))
        $fromaddr = parseAddr(Mail_RFC822::parseAddressList($message->headers["from"]));

    // Attachments are only searched in the top-level part
    $attachments = "";
    $n = 0;
    if(isset($message->parts)) {
        foreach($message->parts as $part) {
            $att = array();
            if(isset($part->disposition) && ($part->disposition == "attachment" || $part->disposition == "inline")) {

                $size = (isset($part->body))?strlen($part->body):0;

                if(isset($part->d_parameters['filename']))
                    $attname = $part->d_parameters['filename'];
                else if(isset($part->ctype_parameters['name']))
                    $attname = $part->ctype_parameters['name'];
                else if(isset($part->headers['content-description']))
                    $attname = $part->headers['content-description'];
                else $attname = "unknown attachment";

                $name = $attname;

                // build html
                $attachments .= <<<ENDA
                <input type="checkbox" name="attachment[]" id="attachment[]" value="$n" checked> <b>$name</b> (<i>$size bytes</i>)<br>
ENDA;
            }
            $n++;
        }
    }

    if ($attachments == "") $attachments = "-";

    $focus = new Email();
    $email_type = 'archived';
}
else {
    echo "error: temporarily email file not found";
    exit();
}
$xtpl=new XTemplate('modules/ZMerge/gui.archivePopup.html');

echo "\n</p>\n";







///////////////////////////////////////////////////////////////////////////////
////    GENERAL TEMPLATE ASSIGNMENTS
$xtpl->assign('MOD', $mod_strings);
$xtpl->assign('APP', $app_strings);

// assign values from email
$xtpl->assign('EML_TO', ($toaddr)?$toaddr:'n/a');
$xtpl->assign('EML_FROM', ($fromaddr)?$fromaddr:'n/a');
$xtpl->assign('EML_SUBJECT', ($message->headers["subject"])?$message->headers["subject"]:'n/a');


if(!isset($focus->id)) $xtpl->assign('USER_ID', $current_user->id);
if(!isset($focus->id) && isset($_REQUEST['contact_id'])) $xtpl->assign('CONTACT_ID', $_REQUEST['contact_id']);

if(isset($_REQUEST['return_module']) && !empty($_REQUEST['return_module'])) {
    $xtpl->assign('RETURN_MODULE', $_REQUEST['return_module']);
} else {
    $xtpl->assign('RETURN_MODULE', 'ZMerge');
    $xtpl->assign('RETURN_ACTION', 'archiveClose');
}
if(isset($_REQUEST['return_action']) && !empty($_REQUEST['return_action']) && ($_REQUEST['return_action'] != 'SubPanelViewer')) {
    $xtpl->assign('RETURN_ACTION', $_REQUEST['return_action']);
} else {
    $xtpl->assign('RETURN_ACTION', 'archiveClose');
}
if(isset($_REQUEST['return_id']) && !empty($_REQUEST['return_id'])) {
    $xtpl->assign('RETURN_ID', $_REQUEST['return_id']);
}

$xtpl->assign('THEME', $theme);
$xtpl->assign('IMAGE_PATH', $image_path);
$xtpl->assign('PRINT_URL', 'index.php?'.$GLOBALS['request_string']);


///////////////////////////////////////////////////////////////////////////////
////    QUICKSEARCH CODE
require_once('include/QuickSearchDefaults.php');
$qsd = new QuickSearchDefaults();
$sqs_objects = array('parent_name' => $qsd->getQSParent(),
                    'assigned_user_name' => $qsd->getQSUser(),



                    );


$json = getJSONobj();

$sqs_objects_encoded = $json->encode($sqs_objects);
$quicksearch_js = $qsd->getQSScripts();
$quicksearch_js .= <<<EOQ
        <script type="text/javascript" language="javascript">sqs_objects = $sqs_objects_encoded;
            function changeQS() {
                //new_module = document.getElementById('parent_type').value;
                new_module = document.EditView.parent_type.value;
                if( new_module == 'Leads' || typeof(disabledModules[new_module]) != 'undefined') { // new_module == 'Contacts' ||
                    sqs_objects['parent_name']['disable'] = true;
                    document.getElementById('parent_name').readOnly = true;
                }
                else {
                    sqs_objects['parent_name']['disable'] = false;
                    document.getElementById('parent_name').readOnly = false;
                }

                sqs_objects['parent_name']['modules'] = new Array(new_module);
                enableQS_ifexists();
            }
            changeQS();

            // newer sugar versions contain the JS enableQS()
            function enableQS_ifexists() {
                var found = (typeof this.window['enableQS'] == 'function');
                if (found === false) {
                    found = ('enableQS' instanceof Function);
                }
                if (found !== false) {
                    enableQS(false);
                }
            }
        </script>
EOQ;
$xtpl->assign('JAVASCRIPT', get_set_focus_js().$quicksearch_js);
////    END QUICKSEARCH CODE
///////////////////////////////////////////////////////////////////////////////

// SugarCRM 6 fix : there is now a fancy image to limit the navigation bar at the left.. for some themes..
if (file_exists($image_path.'globalLinksLeft.png'))
    $xtpl->assign('FANCY_SUGAR6_IMAGE', '<img src="'. $image_path. 'globalLinksLeft.png">');
else if (file_exists('themes/default/images/globalLinksLeft.png') && $theme != "Sugar5")
    $xtpl->assign('FANCY_SUGAR6_IMAGE', '<img src="themes/default/images/globalLinksLeft.png">');
else
    $xtpl->assign('FANCY_SUGAR6_IMAGE', '&nbsp;');




if(isset($_REQUEST['parent_type']) && !empty($_REQUEST['parent_type']) ) {
    $focus->parent_type = $_REQUEST['parent_type'];
}
else
    $focus->parent_type = "Contacts";

if(isset($_REQUEST['parent_type']) && !empty($_REQUEST['parent_type']) && isset($_REQUEST['parent_id']) && !empty($_REQUEST['parent_id'])) {
    $xtpl->assign('OBJECT_ID', $_REQUEST['parent_id']);
    $xtpl->assign('OBJECT_TYPE', $_REQUEST['parent_type']);
}


$xtpl->assign('TYPE',$email_type);



$parent_types = $app_list_strings['record_type_display'];
$disabled_parent_types = ACLController::disabledModuleList($parent_types,false, 'list');

foreach($disabled_parent_types as $disabled_parent_type){
    if($disabled_parent_type != $focus->parent_type){
        unset($parent_types[$disabled_parent_type]);
    }
}


$xtpl->assign('TYPE_OPTIONS', get_select_options_with_id($parent_types, $focus->parent_type));
$xtpl->assign('USER_DATEFORMAT', '('. $timedate->get_user_date_format().')');
$xtpl->assign('PARENT_NAME', $focus->parent_name);
$xtpl->assign('PARENT_ID', $focus->parent_id);
if(empty($focus->parent_type)) {
    $xtpl->assign('PARENT_RECORD_TYPE', '');
} else {
    $xtpl->assign('PARENT_RECORD_TYPE', $focus->parent_type);
}

if(is_admin($current_user) && $_REQUEST['module'] != 'DynamicLayout' && !empty($_SESSION['editinplace'])){
    $record = '';
    if(!empty($_REQUEST['record'])){
        $record =     $_REQUEST['record'];
    }
    $xtpl->assign('ADMIN_EDIT',"<a href='index.php?action=index&module=DynamicLayout&from_action=".$_REQUEST['action'] ."&from_module=".$_REQUEST['module'] ."&record=".$record. "'>".get_image($image_path."EditLayout","border='0' alt='Edit Layout' align='bottom'")."</a>");
}

////    END GENERAL TEMPLATE ASSIGNMENTS
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////
///
/// SETUP PARENT POPUP

$popup_request_data = array(
    'call_back_function' => 'set_return',
    'form_name' => 'EditView',
    'field_to_name_array' => array(
        'id' => 'parent_id',
        'name' => 'parent_name',
        ),
    );

$encoded_popup_request_data = $json->encode($popup_request_data);

/// Users Popup
$popup_request_data = array(
    'call_back_function' => 'set_return',
    'form_name' => 'EditView',
    'field_to_name_array' => array(
        'id' => 'assigned_user_id',
        'user_name' => 'assigned_user_name',
        ),
    );
$xtpl->assign('encoded_users_popup_request_data', $json->encode($popup_request_data));

//
///////////////////////////////////////



$change_parent_button = '<input type="button" name="button" tabindex="2" class="button" '
    . 'title="' . $app_strings['LBL_SELECT_BUTTON_TITLE'] . '" '
    . 'accesskey="' . $app_strings['LBL_SELECT_BUTTON_KEY'] . '" '
    . 'value="'    . $app_strings['LBL_SELECT_BUTTON_LABEL'] . '" '
    . "onclick='open_popup(document.EditView.parent_type.value,600,400,\"&tree=ProductsProd\",true,false,$encoded_popup_request_data);' />\n";
$xtpl->assign("CHANGE_PARENT_BUTTON", $change_parent_button);

$button_attr = '';
if(!ACLController::checkAccess('Contacts', 'list', true)){
    $button_attr = 'disabled="disabled"';
}



///////////////////////////////////////
////    USER ASSIGNMENT
global $current_user;
if(is_admin($current_user) && $_REQUEST['module'] != 'DynamicLayout' && !empty($_SESSION['editinplace'])) {
    $record = '';
    if(!empty($_REQUEST['record'])) {
        $record = $_REQUEST['record'];
    }
    $xtpl->assign('ADMIN_EDIT',"<a href='index.php?action=index&module=DynamicLayout&from_action=".$_REQUEST['action'] ."&from_module=".$_REQUEST['module'] ."&record=".$record. "'>".get_image($image_path."EditLayout","border='0' alt='Edit Layout' align='bottom'")."</a>");
}

if(empty($focus->assigned_user_id) && empty($focus->id))
    $focus->assigned_user_id = $current_user->id;
if(empty($focus->assigned_name) && empty($focus->id))
    $focus->assigned_user_name = $current_user->user_name;
$xtpl->assign('ASSIGNED_USER_OPTIONS', get_select_options_with_id(get_user_array(TRUE, 'Active', $focus->assigned_user_id), $focus->assigned_user_id));
$xtpl->assign('ASSIGNED_USER_NAME', $focus->assigned_user_name);
$xtpl->assign('ASSIGNED_USER_ID', $focus->assigned_user_id);
$xtpl->assign('DURATION_HOURS', $focus->duration_hours);
$xtpl->assign('TYPE_OPTIONS', get_select_options_with_id($parent_types, $focus->parent_type));

if(isset($focus->duration_minutes)) {
    $xtpl->assign('DURATION_MINUTES_OPTIONS', get_select_options_with_id($focus->minutes_values,$focus->duration_minutes));
}
////    END USER ASSIGNMENT
///////////////////////////////////////


///////////////////////////////////////
///
/// SETUP ATTACHMENTS OF THE MAIL
$xtpl->assign('ATTACHMENTS', $attachments);
//// END ATTACHMENTS
///////////////////////////////////////


///////////////////////////////////////
///
/// TEMPLATE OPTIONS

require_once("include/globalControlLinks.php");
$image_server = '';
if(defined('TEMPLATE_URL'))$image_server = TEMPLATE_URL . '/';
$xtpl->assign("IMAGE_SERVER", $image_server);
$xtpl->assign("THEME", $theme);
$xtpl->assign("IMAGE_PATH", $image_path);
$company_logo = $image_path . 'company_logo.png';
if(file_exists('custom/' . $company_logo)){
    $company_logo = 'custom/' . $company_logo;
}
// SugarCRM 5.5 fix
if (!file_exists($company_logo)) {
    $company_logo = 'themes/default/images/company_logo.png';
}

insert_popup_header($theme);
$xtpl->assign('COMPANY_LOGO', $company_logo);
$xtpl->assign("PRINT_URL", "index.php?".$GLOBALS['request_string']);
$xtpl->assign("MODULE_NAME", (isset($currentModule))?$currentModule:'ZMerge');
$xtpl->assign("DATE", date("Y-m-d"));
$xtpl->assign("TITLE", $app_strings['LBL_SEARCH']);

if ($current_user->first_name != '') $xtpl->assign("CURRENT_USER", $current_user->first_name);
else $xtpl->assign("CURRENT_USER", $current_user->user_name);

$xtpl->assign("CURRENT_USER_ID", $current_user->id);
$xtpl->assign("ID", $_REQUEST['record']);

$i = 0;
foreach($global_control_links as $key => $value) {
    if ($key=='users')  {   //represents logout link.
        $xtpl->assign("LOGOUT_LINK", $value['linkinfo'][key($value['linkinfo'])]);
        $xtpl->assign("LOGOUT_LABEL", key($value['linkinfo']));//key value for first element.
        break;
    }
}

if (isset($_REQUEST['query_string'])) $xtpl->assign("SEARCH", $_REQUEST['query_string']);



$header = get_form_header("Email Archive", '', false);
$xtpl->assign('header', $header);


//// END TEMPLATE OPTIONS
///////////////////////////////////////



///////////////////////////////////////
///
/// JS and MAIN processing

echo '<script>var disabledModules='. $json->encode($disabled_parent_types) . ';</script>';
$jsVars = 'var lbl_send_anyways = "'.$mod_strings['LBL_SEND_ANYWAYS'].'";';
$xtpl->assign('JS_VARS', $jsVars);
$xtpl->parse("header");
$xtpl->out("header");
$xtpl->parse("main");
$xtpl->out("main");
echo '<script>checkParentType(document.EditView.parent_type.value, document.EditView.change_parent);</script>';

if (function_exists("get_form_footer"))
    echo get_form_footer();
insert_popup_footer();

require_once('include/javascript/javascript.php');
$javascript = new javascript();
$javascript->setFormName('EditView');
$javascript->setSugarBean($focus);
$skip_fields = array();
if($email_type == 'out') {
    $skip_fields['name'] = 1;
    $skip_fields['date_start'] = 1;
}

$javascript->addToValidateBinaryDependency('parent_name', 'alpha', $app_strings['ERR_SQS_NO_MATCH_FIELD'] . $mod_strings['LBL_MEMBER_OF'], 'false', '', 'parent_id');
$javascript->addToValidateBinaryDependency('parent_type', 'alpha', $app_strings['ERR_SQS_NO_MATCH_FIELD'] . $mod_strings['LBL_MEMBER_OF'], 'false', '', 'parent_id');




$javascript->addToValidateBinaryDependency('user_name', 'alpha', $app_strings['ERR_SQS_NO_MATCH_FIELD'] . $app_strings['LBL_ASSIGNED_TO'], 'false', '', 'assigned_user_id');
echo $javascript->getScript();

?>
<script language="JavaScript">
<!--
window.resizeTo(800,480);


function checkAndResize() {
    if (check_form('EditView')) {
        if (document.getElementById("edit_before_saving").checked) {
            window.resizeTo(1150,600);
        }
        return true;
    }
    else {
        return false;
    }
}
-->
</script>
