<?php
/**
 * Zarafa Z-Merge SugarCRM Connector
 *
 * Copyright (C) 2005 - 2008  Zarafa B.V.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License, version 3,
 * and under the terms of the GNU General Public License, version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU (Affero) General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * and the GNU General Public License along with this program.
 * If not, see <http://www.gnu.org/licenses/>.
 *
 * Created on 07.11.2007 by Sebastian Kummer & Manfred Kutas
 *
 * @package Z-Merge
 * @subpackage SugarCRM-Connector
 */


global $sup_versions, $db_creation, $wait_for_event;

/**
 * supported versions
 */
$sup_versions = array(
                    "4.5.1*",
                    "5.0.0*",
                    "5.1.0*",
                    "5.2.0*",
                    "5.5.*",
                    "6.0.*",
                    "6.1.*",
                  );


/**
 * Strings used to create the database for the connector
 */

$db_creation = array("CREATE TABLE zmerge (
                                  `id` int(11) NOT NULL auto_increment,
                                  `crmid` varchar(36) NOT NULL,
                                  `type` varchar(100) NOT NULL,
                                  `modified` timestamp NOT NULL default CURRENT_TIMESTAMP,
                                  `zmerge` BOOL NOT NULL,
                                  PRIMARY KEY  (`id`),
                                  INDEX `crmid` ( `crmid` ),
                                  INDEX `zmerge` ( `zmerge` )
                                ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;"
                );


/**
 * Strings used to perform on db on uninstall
 */

$db_removal = array("DROP TABLE zmerge;");

/**
 * get a working copy of the constant
 */
$wait_for_event = SG_WAIT_FOR_EVENTS;
?>