<?php
/**
 * Zarafa Z-Merge SugarCRM Connector
 *
 * Copyright (C) 2005 - 2008  Zarafa B.V.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License, version 3,
 * and under the terms of the GNU General Public License, version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU (Affero) General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * and the GNU General Public License along with this program.
 * If not, see <http://www.gnu.org/licenses/>.
 *
 * Created on 07.11.2007 by Sebastian Kummer & Manfred Kutas
 *
 * @package Z-Merge
 * @subpackage SugarCRM-Connector
 */

/**
 * ignore notices
 */
error_reporting(E_ALL ^ E_NOTICE);

/**
 * include connector config file
 */
require('modules/ZMerge/inc.config.php');

/**
 * include some definitions
 */
require('modules/ZMerge/inc.defs.php');

/**
 * load sugar enviroment
 */

global $sugar_version, $timedate, $db, $locale, $current_user;

/**
 * soap
 */
require_once ('include/nusoap.php');

/**
 * include connector components
 */
require('inc.utils.php');
require('inc.functions.php');
require('inc.soap.php');


/**
 * check if the installed sugar version is supported
 */
if (! isCompatibleSugarVersion($sugar_version) ) {
    echo "This version of the Z-Merge SugarCRM connector was not designed and tested for SugarCRM ". $sugar_version;
    exit(0);
}

/**
 * object beans
 */
require_once ('modules/Tasks/Task.php');
require_once ('modules/Contacts/Contact.php');
require_once ('modules/Users/User.php');
require_once ('modules/Calls/Call.php');
require_once ('modules/Meetings/Meeting.php');

/**
 * mark changes in db as made by z-merge
 */
$GLOBALS['zmerge_change'] = 1;    // 1 is true for mysql


/**
 * Begin the HTTP listener service and exit.
 */
global $HTTP_RAW_POST_DATA;

$server->service($HTTP_RAW_POST_DATA);


exit();
?>