<?php
/**
 * Zarafa Z-Merge SugarCRM Connector
 *
 * Copyright (C) 2005 - 2008  Zarafa B.V.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License, version 3,
 * and under the terms of the GNU General Public License, version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU (Affero) General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * and the GNU General Public License along with this program.
 * If not, see <http://www.gnu.org/licenses/>.
 *
 * Created on 07.11.2007 by Sebastian Kummer & Manfred Kutas
 *
 * @package Z-Merge
 * @subpackage SugarCRM-Connector
 */


$dictionary['zmerge'] = array(
    'table' => 'zmerge',
    'fields' => array(
        'id' => array (
            'name' => 'id',
            'vname' => 'LBL_ZMERGEID',
            'type' => 'int',
            'len' => 11,
            'auto_increment'=>true,
            'duplicate_merge' => 'disabled',
            'isnull' => 'false',
            'required'=>true,
          ),
        'crmid' => array(
            'name' => 'crmid',
            'type' => 'id',
            'table' => 'users',
            'isnull' => 'false',
            'len' => 36,
            'dbtype' => 'varchar',
            'required'=>true,
            'vname' => 'LBL_ZMERGECRMID',
        ),
        'type' => array(
            'name' => 'type',
            'type' => 'varchar',
            'len' => 100,
            'isnull' => 'false',
            'required'=>true,
            'vname' => 'LBL_ZMERGETYPE',
        ),
        'modified' => array(
            'name' => 'modified',
            'type' => 'timestamp',
            'default'=> CURRENT_TIMESTAMP,
            'isnull' => 'false',
            'required'=>true,
            'vname' => 'LBL_ZMERGEMODIFIED',
        ),
        'zmerge' => array(
            'name' => 'zmerge',
            'type' => 'int',
            'len' => 1,
            'isnull' => 'false',
            'required'=>true,
            'vname' => 'LBL_ZMERGE',
        ),
    ),

    'indices' => array(
        array('name' =>'PRIMARY',
            'type' =>'primary',
            'fields'=>array('id')
            ),
        array('name' =>'crmid',
            'type' =>'index',
            'fields'=>array('crmid')
            ),
        array('name' =>'zmerge',
            'type' =>'index',
            'fields'=>array('zmerge')
            ),
    ),
);
?>