<?php
/** 
 * Zarafa Z-Merge SugarCRM Connector
 * 
 * Copyright (C) 2005 - 2008  Zarafa B.V.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License, version 3, 
 * and under the terms of the GNU General Public License, version 3,
 * as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU (Affero) General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * and the GNU General Public License along with this program.  
 * If not, see <http://www.gnu.org/licenses/>.
 *  
 * Created on 07.11.2007 by Sebastian Kummer & Manfred Kutas
 *
 * @package Z-Merge
 * @subpackage SugarCRM
 */

$manifest = array(
	//Contains which SugarCRM Editions the package can be installed on.
	'acceptable_sugar_flavors' => array(),

	// only install on the following regex sugar versions (if empty, no check)
	'acceptable_sugar_versions' => array('4.5.1*', '5.0.0*', '5.1.0*', '5.2.0*', '5.5.*', '6.0.*', '6.1.*'),

	//makes module removable.
	'is_uninstallable' => true,

	// name of new code
	'name' => 'Z-Merge SugarCRM connector',

	// description of new code
	'description' => 'Zarafa serverside syncronisation and WebAccess e-mail archival for SugarCRM',

	// author of new code
	'author' => 'Zarafa',

	// date published
	'published_date' => '2011/03/18',

	// version of code
	'version' => '1.0-beta7 (486)',

	// type of code (valid choices are: full, langpack, module, patch, theme )
	'type' => 'module',

	// icon for displaying in UI (path to graphic contained within zip package)
	'icon' => 'images/zmerge.gif',

	'dependencies' => array (),
	 // flag to specify whether to remove database tables on uninstallation
	'remove_tables' => 'prompt',
);


$installdefs = array(
    'id'=> 'ZMerge',
//    'image_dir'=>'<basepath>/images',
    'copy' => array(
                        array('from'=> '<basepath>/ZMerge',
                              'to'=> 'modules/ZMerge',
                              ),
                        array('from'=> '<basepath>/custom',
                              'to'=> 'custom',
                              ),
                    ),

    
    'language'=> array(array('from'=> '<basepath>/language/en_us.lang.php', 
                    'to_module'=> 'application',
                    'language'=>'en_us'
                    ),
                    ),
/*    'custom_fields'=>array(
                        //will be referenced as sudo_name_c   - _c indicates a custom field
                        //current types are varchar,textarea,double,float,int,date,bool,enum (select), relate
                        array('name'=>'zmerge',
                                'label'=>'Sync with Z-Merge',
                                'type'=>'bool',
                                'require_option'=>'required',
                                'default_value'=>'1',
                                'ext1'=>'',
                                'ext2'=>'',
                                'ext3'=>'',
                                'audited'=>0,
                                'module'=>'Contacts',
                    ),
                    array('name'=>'zmerge',
                                'label'=>'Sync with Z-Merge',
                                'type'=>'bool',
                                'require_option'=>'required',
                                'default_value'=>'1',
                                'ext1'=>'',
                                'ext2'=>'',
                                'ext3'=>'',
                                'audited'=>0,
                                'module'=>'Calls',
                    ),
                    array('name'=>'zmerge',
                                'label'=>'Sync with Z-Merge',
                                'type'=>'bool',
                                'require_option'=>'required',
                                'default_value'=>'1',
                                'ext1'=>'',
                                'ext2'=>'',
                                'ext3'=>'',
                                'audited'=>0,
                                'module'=>'Tasks',
                    ),
                    array('name'=>'zmerge',
                                'label'=>'Sync with Z-Merge',
                                'type'=>'bool',
                                'require_option'=>'required',
                                'default_value'=>'1',
                                'ext1'=>'',
                                'ext2'=>'',
                                'ext3'=>'',
                                'audited'=>0,
                                'module'=>'Meetings',
                    ),
                    array('name'=>'zmerge',
                                'label'=>'Sync with Z-Merge',
                                'type'=>'bool',
                                'require_option'=>'required',
                                'default_value'=>'1',
                                'ext1'=>'',
                                'ext2'=>'',
                                'ext3'=>'',
                                'audited'=>0,
                                'module'=>'Notes',
                    ),

                    ),
*/
);

?>
